/*********************************************************************
 * TP1, info528 (mathématiques pour l'informatique)
 * décodage des QR codes
 * automne 2012
 * L3-STIC info
 *
 * étudiant : Vizir Iznogood
 ********************************************************************/

/* voir le fichier qrcodes.h pour des commentaires sur l'utilisation des
 * fonctions */
#include "./qrcodes.h"


/*******************************************
 * parties fixes d'un QR code de version 1 *
 *******************************************/

/* renvoie le nombre de pixels fixes incorrects */
int check_fixed_bits_version1(QRCode qr) {
  /* 1 pour noir ; 0 pour blanc ; 2 pour les bits non-constants */
  char FIXED[21][21] = {
    {1,1,1,1,1,1,1,0,2,2,2,2,2,0,1,1,1,1,1,1,1},
    {1,0,0,0,0,0,1,0,2,2,2,2,2,0,1,0,0,0,0,0,1},
    {1,0,1,1,1,0,1,0,2,2,2,2,2,0,1,0,1,1,1,0,1},
    {1,0,1,1,1,0,1,0,2,2,2,2,2,0,1,0,1,1,1,0,1},
    {1,0,1,1,1,0,1,0,2,2,2,2,2,0,1,0,1,1,1,0,1},
    {1,0,0,0,0,0,1,0,2,2,2,2,2,0,1,0,0,0,0,0,1},
    {1,1,1,1,1,1,1,0,1,0,1,0,1,0,1,1,1,1,1,1,1},
    {0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0},
    {2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {2,2,2,2,2,2,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {2,2,2,2,2,2,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {0,0,0,0,0,0,0,0,1,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,1,1,1,1,1,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,0,0,0,0,0,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,0,1,1,1,0,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,0,1,1,1,0,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,0,1,1,1,0,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,0,0,0,0,0,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2},
    {1,1,1,1,1,1,1,0,2,2,2,2,2,2,2,2,2,2,2,2,2}
  };
  int nb_errors = 0;
  /*
   * À COMPLÉTER
   */
  return nb_errors;
}



/*********************
 * format du QR code *
 *********************/

/* récupère les 15 bits de format, aux deux endroits
 * sans appliquer le masque */
/* TODO : use SIZE_V1 instead of 21 */
void get_raw_format_bits(QRCode qr, bit format[2][15]) {
  /*
   * À COMPLÉTER
   */
}


/* récupère les 15 bits de format, aux deux endroits
 * en appliquant le masque */
void get_format_bits(QRCode qr, bit format[2][15]) {
  bit MASK[15] = { 1,0,1,0,1,0,0,0,0,0,1,0,0,1,0 };
  /*
   * À COMPLÉTER
   */
}


/* récupère les 5 bits de format dans "format".
 * S'il avait des erreurs qu'on n'a pas pu corriger, la valeur de retour est
 * -1, sinon c'est 0. */
int get_format(QRCode qr, int *correction_level, int *mask) {
  /*
   * À COMPLÉTER
   */
  return(-1);
}



/**********************
 * données du QR code *
 **********************/


/* applique le masque numéro m au qrcode : voir
 * http://en.wikiversity.org/wiki/Reed%E2%80%93Solomon_codes_for_coders#Masking 
 * pour la liste des masques */
void data_mask(QRCode qr, int mask) {
  /*
   * À COMPLÉTER
   */
  exit(-1);
}


/* récupère un octet de données à partir des coordonnées du coin haut/gauche
 * du rectangle correspondant */
byte get_upward_byte(QRCode qr, int i, int j) {
  byte b = 0;
  /*
   * À COMPLÉTER
   */
  return(b);
}

byte get_downward_byte(QRCode qr, int i, int j) {
  byte b = 0;
  /*
   * À COMPLÉTER
   */
  return(b);
}

/* récupère les 26 octets d'un QR code */
void get_data_bytes(QRCode qr, byte *data) {
  int i;
  for (i=0; i<3; i++) data[i] = get_upward_byte(qr, 17-4*i, 19);
  for (i=0; i<3; i++) data[i+3] = get_downward_byte(qr, 9+4*i, 17);
  for (i=0; i<3; i++) data[i+6] = get_upward_byte(qr, 17-4*i, 15);
  for (i=0; i<3; i++) data[i+9] = get_downward_byte(qr, 9+4*i, 13);
  for (i=0; i<3; i++) data[i+12] = get_upward_byte(qr, 17-4*i, 11);
  data[15] = get_upward_byte(qr, 4, 11);
  data[16] = get_upward_byte(qr, 0, 11);
  data[17] = get_downward_byte(qr, 0, 9);
  data[18] = get_downward_byte(qr, 4, 9);
  for (i=0; i<3; i++) data[i+19] = get_downward_byte(qr, 9+4*i, 9);
  data[22] = get_upward_byte(qr, 9, 7);
  data[23] = get_downward_byte(qr, 9, 4);
  data[24] = get_upward_byte(qr, 9, 2);
  data[25] = get_downward_byte(qr, 9, 0);
}



/************
 * décodage *
 ************/

/* récupère un bit dans le tableau des octets de données */
bit get_bit(const byte *data, int nb) {
  /*
   * À COMPLÉTER
   */
  return(0);
}

/* récupère plusieurs bits consécutifs dans le tableau des octets de données
 * Le résultat est renvoyé dans un entier. Il ne faut donc pas demander trop
 * de bits en même temps ! */
unsigned int get_bits(const byte *data, int offset, int nb){
  unsigned int r = 0;
  /*
   * À COMPLÉTER
   */
  return(r);
}


/* récupère les 4 bits du mode à un offset donné */
int get_mode(const byte *data, int offset) {
  return(get_bits(data, offset,4));
}


/* récupère le nombre de symboles suivant un mode */
int get_length(const byte *data, int offset, int mode) {
  switch (mode) {
    case NUMERIC_MODE:
      return(get_bits(data,offset+4,10));
      break;
    case ALPHANUMERIC_MODE:
      return(get_bits(data,offset+4,9));
      break;
    case BYTE_MODE:
      return(get_bits(data,offset+4,8));
      break;
    case KANJI_MODE:
      return(get_bits(data,offset+4,8));
      break;
    default:
      fprintf(stderr, "Unknown mode (%u)! Aborting...", mode);
      exit(-1);
  }
}


/* les fonctions de décodages des différents modes. La chaine result
 * doit déjà être allouée...
 * Elles renvoient le nombre de bits qu'elles ont lus dans le tableau des
 * données.*/
int decode_bytes(const byte *data, int offset, int nb, char *result) {
  int bits_read = 0;
  /*
   * À COMPLÉTER
   */
  return(bits_read);
}

int decode_numeric(const byte *data, int offset, int nb, char *result) {
  char table[10] = { '0','1','2','3','4','5','6','7','8','9' };
  /*
   * les chiffres sont groupés par blocs de 3, et on code en fait leur
   * représentation en base 10 sur 10 bits.
   * S'il reste deux chiffres seuls, on code leur représentation en base 10 sur 7 bits.
   * S'il reste un chiffre seul, on code sa représentation en base 10 sur 4 bits.
   */
  int bits_read = 0;
  /*
   * À COMPLÉTER
   */
  return(bits_read);
}

int decode_alphanumeric(const byte *data, int offset, int nb, char *result) {
                                                               /* indices  */
  char table[45] = { '0','1','2','3','4','5','6','7','8','9',  /* 0 -- 9   */
                     'A','B','C','D','E','F','G','H','I','J',  /* 10 -- 19 */
                     'K','L','M','N','O','P','Q','R','S','T',  /* 20 -- 29 */
                     'U','V','W','X','Y','Z',' ','$','%','*',  /* 30 -- 39 */
                     '+','-', '.', '/',':' };                  /* 40 -- 44 */
  /*
   * Les 45 caractères autorisés sont donnés dans la table ci dessus.
   * les caractères sont groupés par blocs de 2, et on code en fait leur
   * représentation en base 45 (45*45=2025 possibilités) sur 11 bits.
   * S'il reste un caractère seul, on code sa représentation en base 45 sur 6 bits.
   */
  int bits_read = 0;
  /*
   * À COMPLÉTER
   */
  return(bits_read);
}



/**************************************************
 * teste un fichier généré par qrencode / convert *
 **************************************************/

/* affiche toutes les informations importantes du QR code contenu dans un
 * fichier */
void info_file(const char *filename, int margin_size, int module_size) {
  /*
   * À COMPLÉTER
   */
}


/* décode et affiche le contenu du QR code contenu dans un fichier */
void decode_file(const char *filename, int margin_size, int module_size) {
  /*
   * À COMPLÉTER
   */
}


/* vim: set tabstop=2 shiftwidth=2 : */
